﻿using System;

namespace Demo.Demos.TravelRequest
{
    [Serializable]
    public class TripViewModel
    {
        #region Fields (1)
        private TravelViewModel m_Parent = default(TravelViewModel);
        #endregion

        #region Properties (8)
        public DateTime DepartureDate { get; set; }
        public String From { get; set; }
        public bool IncludeCarRental { get; set; }
        public bool IncludeHotel { get; set; }
        public TravelViewModel Parent
        {
            get
            {
                return m_Parent;
            }
        }
        public DateTime ReturnDate { get; set; }
        public bool RoundTrip { get; set; }
        public String To { get; set; }
        #endregion

        #region Constructors (1)
        public TripViewModel(TravelViewModel parent)
        {
             if (parent == null)  throw new NullReferenceException("parent");
            m_Parent = parent;
            this.DepartureDate = DateTime.Now;
            this.ReturnDate = DateTime.Now;
        }
        #endregion
    }
}