﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Demo.Demos;
using Carbon.Web.Forms;
using Carbon.Web.Forms.Controls;
using System.Data.SqlClient;
using System.Configuration;

namespace Demo.Tests
{
    [Serializable]
    public class ReplaceThing
    {
         private String m_Textic= default(String);
					public String Textic
					{
						get
						{
							return m_Textic;
						}
						set
						{
							m_Textic = value;
						}
					} 
    }

    [Serializable]
    public class TestModel
    {
        public TestModel()
        {
        }

        
        private List<ReplaceThing> m_Slova = default(List<ReplaceThing>);
        private bool m_Slova_calculated = false;
        public List<ReplaceThing> Slova
        {
            get
            {
                if (!m_Slova_calculated)
                {
                    m_Slova = new List<ReplaceThing>();
                    m_Slova.Add(new ReplaceThing() { Textic = "a" });
                    m_Slova.Add(new ReplaceThing() { Textic = "b" });
                    m_Slova_calculated = true;
                }

                return m_Slova;
            }
        } 
    }

    public class Test1DataContextControl : DataContextControl<TestModel>
    {
        protected override TestModel CreateViewModel()
        {
            return new TestModel();
        }
    }

    public partial class Test1 : System.Web.UI.Page
    {
        protected Test1DataContextControl ctrl_ContextControl = null;
        public Test1DataContextControl Control_ContextControl
        {
          get
          {
             if (ctrl_ContextControl == null) throw new NullReferenceException();
            return ctrl_ContextControl;
          }
        }
        protected void ReplaceItems(object sender, EventArgs args)
        {
            List<ReplaceThing> replace = Control_ContextControl.ViewModel.Slova;

            replace.Insert(0, replace[1]);
            replace.RemoveAt(2);
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            using (SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["PersistanceService"].ConnectionString))
            {
                connection.Open();
                SqlCommand command = connection.CreateCommand();
                command.CommandText = @"
/****** Object:  Table [dbo].[Blobs]    Script Date: 06/28/2012 09:47:51 ******/
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
CREATE TABLE [dbo].[Blobs](
	[Id] [bigint] IDENTITY(1,1) NOT NULL,
	[Key] [uniqueidentifier] NOT NULL,
	[Name] [nvarchar](256) NULL,
	[Data] [varbinary](max) NOT NULL,
	[Created] [datetime] NOT NULL,
	[Modified] [datetime] NOT NULL,
 CONSTRAINT [PK_Blobs] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
SET ANSI_PADDING OFF
/****** Object:  StoredProcedure [dbo].[Blobs.Update]    Script Date: 06/28/2012 09:47:54 ******/
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [dbo].[Blobs.Update]
	-- Add the parameters for the stored procedure here
@id bigint,
@key uniqueidentifier,
@name	nvarchar(256),
@data	varbinary(MAX)
	
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
	DECLARE @now as datetime;
	set @now = GetUtcDate();
	UPDATE Blobs SET [Name] = @name, [Data] = @data, [Modified] = @now WHERE [Id] = @id AND [Key] = @key
	
	IF @@rowcount <> 1
		RAISERROR('Error during update', 16, 1)
END
/****** Object:  StoredProcedure [dbo].[Blobs.Insert]    Script Date: 06/28/2012 09:47:54 ******/
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [dbo].[Blobs.Insert]
	-- Add the parameters for the stored procedure here
	@key uniqueidentifier,
@name	nvarchar(256),
@data	varbinary(MAX)

AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
	DECLARE @now as datetime;
	set @now = GetUtcDate();
	INSERT INTO Blobs([Key], [Name], [Data], [Created], [Modified]) VALUES (@key, @name, @data, @now, @now)
	
	SELECT @@identity AS Id
END
/****** Object:  StoredProcedure [dbo].[Blobs.Get]    Script Date: 06/28/2012 09:47:54 ******/
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [dbo].[Blobs.Get]
	-- Add the parameters for the stored procedure here
@id bigint,
@key uniqueidentifier
	
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
	SELECT * FROM Blobs WHERE [Id] = @id AND [Key] = @key
	

END
/****** Object:  StoredProcedure [dbo].[Blobs.Delete]    Script Date: 06/28/2012 09:47:54 ******/
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [dbo].[Blobs.Delete]
	-- Add the parameters for the stored procedure here
@id bigint,
@key uniqueidentifier
	
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
	DECLARE @now as datetime;
	set @now = GetUtcDate();
	DELETE FROM Blobs WHERE [Id] = @id AND [Key] = @key
	
	IF @@rowcount <> 1
		RAISERROR('Error during delete', 16, 1)
END
";

                command.ExecuteNonQuery();
            }
        }
    }
}