﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Carbon.Web.Forms
{
    public class CollectionChangingEventArgs<T> : EventArgs
    {
        private T m_ItemToAdd = default(T);
        public T ItemToAdd
        {
            get
            {
                return m_ItemToAdd;
            }
        }

        private T m_ItemToRemove = default(T);
        public T ItemToRemove
        {
            get
            {
                return m_ItemToRemove;
            }
        }

        public CollectionChangingEventArgs(T itemToAdd, T itemToRemove)
            : base()
        {
            if (itemToAdd == null) throw new ArgumentNullException("itemToAdd");
            if (itemToRemove == null) throw new ArgumentNullException("itemToRemove");

            this.m_ItemToAdd = itemToAdd;
            this.m_ItemToRemove = itemToRemove;
        }



    }
}
