﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Carbon.Web.Forms
{
    public class ControlDescendantsUpdatedEventArgs : EventArgs
    {
        private IViewControl m_Control = default(IViewControl);
        public IViewControl Control
        {
            get
            {
                return m_Control;
            }
        }
        
        private UpdateControlStageEnum m_Stage = default(UpdateControlStageEnum);
        public UpdateControlStageEnum Stage
        {
            get
            {
                return m_Stage;
            }
        } 

        public ControlDescendantsUpdatedEventArgs(IViewControl control, UpdateControlStageEnum stage)
            : base()
        {
            if (control == null) throw new ArgumentNullException("control");

            this.m_Control = control;
            this.m_Stage = stage;
        }
    }
}
